<template>
  <q-page class="flex-center">
    <template>
      <div class="q-pa-md row items-start q-gutter-md">
        <q-card
          class="text-white"
          style="background: radial-gradient(circle, #35a2ff 0%, #014a88 100%); width: 100%; max-width: 200px"
        >
          <q-card-section>
            <div class="text-h6">Downline: 90 คน</div>
          </q-card-section>
          <q-separator dark inset />
        </q-card>
        <q-card
          class="cursor-pointer text-white"
          style="background: radial-gradient(circle, #35a2ff 0%, #014a88 100%); max-width: auto;"
        >
          <q-card-section>
            <div class="text-h6">Credit Win-Lose: +100,000,000,000.00 TH</div>
          </q-card-section>
          <q-separator dark inset />
        </q-card>

        <q-card
          class="cursor-pointer text-white"
          @click="open_deposit"
          style="background: radial-gradient(circle, #35a2ff 0%, #014a88 100%); width: 100%; max-width: 100px"
        >
          <q-card-section>
            <div class="text-h6">+ ฝากเงิน</div>
          </q-card-section>
          <q-separator dark inset />
        </q-card>

        <q-card
          class="cursor-pointer text-white"
          style="background: radial-gradient(circle, #35a2ff 0%, #014a88 100%); width: 100%; max-width: 100px"
        >
          <q-card-section>
            <div class="text-h6">- ถอนเงิน</div>
          </q-card-section>
          <q-separator dark inset />
        </q-card>

        <q-card class="q-pa-md">
          <q-card-section>
            <div class="text-h6">Filter</div>
          </q-card-section>
          <q-card-section class="q-gutter-sm">
            <el-input
              placeholder="Please Name"
              v-model="filter.name"
            ></el-input>
            <el-date-picker
              v-model="filter.date"
              type="daterange"
              range-separator="To"
              start-placeholder="Start date"
              end-placeholder="End date"
            >
            </el-date-picker>
          </q-card-section>
          <q-card-section class="q-gutter-sm">
            <div class="text-subtitle2">Type Game</div>
            <q-option-group
              v-model="filter.type"
              :options="type_options"
              inline
              color="green"
              type="checkbox"
            />
          </q-card-section>
        </q-card>
      </div>

      <div class="q-pa-md">
        <q-table
          :rows-per-page-options="[15, 25, 50]"
          :data="tableData"
          :columns="columns"
          :separator="separator"
          dense
          row-key="col1"
          class="my-sticky-header-column-table"
        >
          <div
            slot="header"
            slot-scope="props"
            style="display: contents; vertical-align: middle; text-align: center"
          >
            <q-tr>
              <q-th rowspan="2" class="bg-blue-9 text-white">Account</q-th>
              <q-th rowspan="2" class="bg-blue-9 text-white">Contact</q-th>
              <q-th rowspan="2" class="bg-blue-9 text-white">Cur</q-th>
              <q-th rowspan="2" class="bg-blue-9 text-white">Amount</q-th>
              <q-th rowspan="2" class="bg-blue-9 text-white">Valid Amount</q-th>
              <q-th rowspan="2" class="bg-blue-9 text-white">Strake Count</q-th>
              <q-th rowspan="2" class="bg-blue-9 text-white">Gross Comm</q-th>
              <q-th colspan="3" class="bg-blue-10 text-white">Member</q-th>
              <q-th colspan="3" class="bg-blue-10 text-white">Agent</q-th>
              <q-th colspan="3" class="bg-blue-10 text-white">Senior</q-th>
              <q-th colspan="3" class="bg-blue-10 text-white"
                >Share Holder</q-th
              >
              <q-th colspan="3" class="bg-blue-10 text-white">Company</q-th>
            </q-tr>
            <q-tr>
              <q-th class="bg-light-blue-5 text-white">W/L</q-th>
              <q-th class="bg-light-blue-5 text-white">Com</q-th>
              <q-th class="bg-light-blue-5 text-white"
                >Win Lose <br />Comm</q-th
              >
              <q-th class="bg-light-blue-5 text-white">W/L</q-th>
              <q-th class="bg-light-blue-5 text-white">Com</q-th>
              <q-th class="bg-light-blue-5 text-white"
                >Win Lose <br />Comm</q-th
              >
              <q-th class="bg-light-blue-5 text-white">W/L</q-th>
              <q-th class="bg-light-blue-5 text-white">Com</q-th>
              <q-th class="bg-light-blue-5 text-white"
                >Win Lose <br />Comm</q-th
              >
              <q-th class="bg-light-blue-5 text-white">W/L</q-th>
              <q-th class="bg-light-blue-5 text-white">Com</q-th>
              <q-th class="bg-light-blue-5 text-white"
                >Win Lose <br />Comm</q-th
              >
              <q-th class="bg-light-blue-5 text-white">W/L</q-th>
              <q-th class="bg-light-blue-5 text-white">Com</q-th>
              <q-th class="bg-light-blue-5 text-white"
                >Win Lose <br />Comm</q-th
              >
            </q-tr>
          </div>
          <template slot="body" slot-scope="props">
            <q-tr :props="props">
              <q-td
                :class="{
                  'bg-yellow-5': col.field.includes('_winlose_commission')
                }"
                v-for="col in props.cols"
                :key="col.name"
                :props="props"
              >
                {{ props.row[col.field] }}
              </q-td>
            </q-tr>
          </template>
          <template v-slot:bottom-row>
            <q-tr>
              <q-td> Total</q-td>
              <q-td v-for="index in 19"> col</q-td>
            </q-tr>
          </template>
        </q-table>
      </div>
    </template>

    <!-- deposit -->
    <q-dialog
      v-model="modal_deposit"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <div class="text-h6">+ ฝากเงิน</div>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form"
            ref="form"
            :rules="rules"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Username" prop="member">
              <q-select
                filled
                v-model="form.member"
                use-input
                use-chips
                input-debounce="0"
                :options="member_options"
                @filter="filterFn"
                style="width: 250px"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
            <el-form-item label="Amount" prop="amount">
              <currency-input v-model="form.amount" currency="THB" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn push rounded color="primary" @click="deposit()">Submit</q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>

    <!-- withdraw -->
    <q-dialog
      v-model="modal_withdraw"
      persistent
      transition-show="flip-down"
      transition-hide="flip-up"
    >
      <q-card style="width: 700px; max-width: 80vw;">
        <q-bar>
          <div class="text-h6">+ ถอนเงิน</div>
          <q-space />
          <q-btn dense flat icon="close" v-close-popup>
            <q-tooltip>Close</q-tooltip>
          </q-btn>
        </q-bar>
        <q-card-section>
          <el-form
            :model="form"
            ref="form"
            :rules="rules"
            label-width="120px"
            class="demo-dynamic"
          >
            <el-form-item label="Name" prop="name">
              <q-select
                filled
                v-model="form.user"
                use-input
                use-chips
                input-debounce="0"
                :options="member_options"
                @filter="filterFn"
                style="width: 250px"
                option-value="value"
                option-label="label"
                option-disable="inactive"
                emit-value
                map-options
              />
            </el-form-item>
            <el-form-item label="Amount" prop="amount">
              <currency-input v-model="form.amount" currency="THB" />
            </el-form-item>
          </el-form>
        </q-card-section>
        <q-card-actions align="right" class="bg-primary text-white">
          <q-btn push rounded color="primary" @click="deposit()">Submit</q-btn>
          <q-btn push rounded color="primary" v-close-popup>Cancel</q-btn>
        </q-card-actions>
      </q-card>
    </q-dialog>
  </q-page>
</template>

<script>
export default {
  name: "PageIndex",
  data() {
    return {
      tableData: [],
      example: [
        {
          account: "realtech23",
          contact: "realtech23",
          currency: "THB",
          amount: "100.00",
          valid_amount: "100.00",
          stake_count: "100.00",
          gross_commission: "100.00",
          member_winlose: "100.00",
          member_commission: "100.00",
          member_winlose_commission: "100.00",
          agent_winlose: "100.00",
          agent_commission: "100.00",
          agent_winlose_commission: "100.00",
          senior_winlose: "100.00",
          senior_commission: "100.00",
          senior_winlose_commission: "100.00",
          shareholder_winlose: "100.00",
          shareholder_commission: "100.00",
          shareholder_winlose_commission: "100.00",
          company_winlose: "100.00",
          company_commission: "100.00",
          company_winlose_commission: "100.00"
        }
      ],
      columns: [
        {
          name: "account",
          align: "left",
          label: "account",
          field: "account",
          sortable: true
        },
        {
          name: "contact",
          align: "left",
          label: "contact",
          field: "contact",
          sortable: true
        },
        {
          name: "currency",
          align: "left",
          label: "currency",
          field: "currency",
          sortable: true
        },
        {
          name: "amount",
          align: "left",
          label: "amount",
          field: "amount",
          sortable: true
        },
        {
          name: "valid_amount",
          align: "right",
          label: "valid_amount",
          field: "valid_amount",
          sortable: true
        },
        {
          name: "stake_count",
          align: "right",
          label: "stake_count",
          field: "stake_count",
          sortable: true
        },
        {
          name: "gross_commission",
          align: "right",
          label: "gross_commission",
          field: "gross_commission",
          sortable: true
        },
        {
          name: "member_winlose",
          align: "right",
          label: "member_winlose",
          field: "member_winlose",
          sortable: true
        },
        {
          name: "member_commission",
          align: "right",
          label: "member_commission",
          field: "member_commission",
          sortable: true
        },
        {
          name: "member_winlose_commission",
          align: "right",
          label: "member_winlose_commission",
          field: "member_winlose_commission",
          sortable: true
        },
        {
          name: "agent_winlose",
          align: "right",
          label: "agent_winlose",
          field: "agent_winlose",
          sortable: true
        },
        {
          name: "agent_commission",
          align: "right",
          label: "agent_commission",
          field: "agent_commission",
          sortable: true
        },
        {
          name: "agent_winlose_commission",
          align: "right",
          label: "agent_winlose_commission",
          field: "agent_winlose_commission",
          sortable: true
        },
        {
          name: "senior_winlose",
          align: "right",
          label: "senior_winlose",
          field: "senior_winlose",
          sortable: true
        },
        {
          name: "senior_commission",
          align: "right",
          label: "senior_commission",
          field: "senior_commission",
          sortable: true
        },
        {
          name: "senior_winlose_commission",
          align: "right",
          label: "senior_winlose_commission",
          field: "senior_winlose_commission",
          sortable: true
        },
        {
          name: "shareholder_winlose",
          align: "right",
          label: "shareholder_winlose",
          field: "shareholder_winlose",
          sortable: true
        },
        {
          name: "shareholder_commission",
          align: "right",
          label: "shareholder_commission",
          field: "shareholder_commission",
          sortable: true
        },
        {
          name: "shareholder_winlose_commission",
          align: "right",
          label: "shareholder_winlose_commission",
          field: "shareholder_winlose_commission",
          sortable: true
        },
        {
          name: "company_winlose",
          align: "right",
          label: "company_winlose",
          field: "company_winlose",
          sortable: true
        },
        {
          name: "company_commission",
          align: "right",
          label: "company_commission",
          field: "company_commission",
          sortable: true
        },
        {
          name: "company_winlose_commission",
          align: "right",
          label: "company_winlose_commission",
          field: "company_winlose_commission",
          sortable: true
        }
      ],
      separator: "cell",
      filter: { type: [] },
      role_options: [],
      group: ["op1"],
      options: [
        { label: "Option 1", value: "op1" },
        { label: "Option 2", value: "op2" },
        { label: "Option 3", value: "op3" }
      ],
      teal: true,
      orange: false,
      red: false,
      cyan: true,
      type_options: [],
      modal_deposit: false,
      modal_withdraw: false,
      form: {},
      member_options: [],
      rules: {
        amount: [
          { required: true, message: "Please input amount", trigger: "blur" }
        ],
        member: [
          {
            required: true,
            message: "Please select username",
            trigger: "change"
          }
        ]
      }
    };
  },
  async created() {
    await this.get_type();
    const columns = Object.keys(this.example[0]);
    for (let index = 0; index < 20; index++) {
      let data = {};
      data[columns[0]] = "realtech" + Math.floor(1 + Math.random() * 9999999);
      data[columns[1]] = data[columns[0]];
      data[columns[2]] = "THB";
      for (let i = 3; i < columns.length; i++) {
        data[columns[i]] = Math.floor(1 + Math.random() * 99999);
      }
      this.tableData.push(data);
    }
  },

  methods: {
    async get_type() {
      let ctx = this;
      this.$services.typegame
        .read({})
        .then(function(data) {
          data.forEach(row => {
            ctx.type_options.push({ value: row.id, label: row.name });
          });
        })
        .catch(function(e) {
          ctx.$services.error(e.response, ctx.$route);
        });
    },

    open_deposit() {
      this.form = {};
      this.member_options = [];
      this.modal_deposit = true;
    },

    async deposit() {
      let ctx = this;
      this.$refs.form.validate(valid => {
        if (valid) {
          this.$services.credit
            .deposit(this.form)
            .then(function(data) {
              ctx.modal_deposit = false;
              ctx.$services.success("Deposit Success");
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$route);
            });
        }
      });
      // console.log('deposit:', this.form)
    },

    async filterFn(val, update) {
      let ctx = this;
      update(() => {
        if (val === "") {
          console;
        } else {
          this.member_options = [];
          this.$services.member
            .read({ param: "like", user: val })
            .then(function(data) {
              data.forEach(row => {
                ctx.member_options.push({ value: row.id, label: row.user });
              });
            })
            .catch(function(e) {
              ctx.$services.error(e.response, ctx.$route);
            });
        }
      });
    }
  }
};
</script>

<style lang="sass">
.my-sticky-header-column-table
  height: 600px
  max-width: 100%

  td:first-child
    background-color: #c1f4cd !important

  tr th
    position: sticky
    z-index: 2
    background: #fff

  thead tr:last-child th
    z-index: 3
  thead tr:first-child th
    top: 0
    z-index: 1
  tr:first-child th:first-child
    z-index: 3

  td:first-child
    z-index: 1

  td:first-child, th:first-child
    position: sticky
    left: 0
</style>

<style type="text/css">
.el-input {
  width: 200px;
}

.el-range-editor.el-input__inner {
  width: 410px;
}

body {
  font-size: 11px;
}

.q-card__section--vert {
  padding: 6px;
}
</style>
